﻿using System;
using System.Windows;
using System.Windows.Media;

namespace TextOutlineGenerator
{
    public class FormattedTextBlock : FrameworkElement
    {
        public static readonly DependencyProperty FormattedTextProperty =
            DependencyProperty.Register("FormattedText",
                typeof(FormattedText),
                typeof(FormattedTextBlock),
                new FrameworkPropertyMetadata(null, FrameworkPropertyMetadataOptions.AffectsMeasure |
                                             FrameworkPropertyMetadataOptions.AffectsRender));

        public FormattedText FormattedText
        {
            set { SetValue(FormattedTextProperty, value); }
            get { return (FormattedText)GetValue(FormattedTextProperty); }
        }

        protected override Size MeasureOverride(Size availableSize)
        {
            if (FormattedText != null)
                return new Size(FormattedText.WidthIncludingTrailingWhitespace, FormattedText.Height);

            return base.MeasureOverride(availableSize);
        }

        protected override void OnRender(DrawingContext dc)
        {
            if (FormattedText != null)
                dc.DrawText(FormattedText, new Point(0, 0));
        }
    }
}